"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var Bluebird = require("bluebird");
var debug = require("debug");
var lodash_1 = require("lodash");
var common_1 = require("./common");
var lb_1 = require("./lb");
var client_1 = require("./client");
var naming_1 = require("./naming");
var log = debug('grpcHelper:helper');
Promise = Bluebird;
var GRPCHelper = /** @class */ (function () {
    function GRPCHelper(opts) {
        var _this = this;
        this.opts = Object.assign({
            timeoutInMS: 5000,
            metrics: true,
        }, opts);
        this.opts.healthCheck = Object.assign({
            enable: false,
            timeoutInMS: 5000,
            protoPath: path.resolve(__dirname, 'health.proto'),
        }, opts.healthCheck);
        var clientCreator = new client_1.HelperClientCreator(this.opts);
        var _a = this.parseSDUri(this.opts.sdUri), type = _a.type, addr = _a.addr;
        log('service discovery use %s', type);
        var resolver;
        if (type === 'dns') {
            resolver = new naming_1.DNSResolver();
        }
        else if (type === 'static') {
            resolver = new naming_1.StaticResolver();
        }
        else {
            throw new common_1.GRPCHelperError("resolver not implemented: " + type);
        }
        var createClient = clientCreator.createClientFromAddress.bind(clientCreator);
        this.lb = new lb_1.RoundRobinBalancer(resolver, createClient);
        this.lb.start(addr);
        var methodNames = clientCreator.getMethodNames();
        lodash_1.each(methodNames, function (method) {
            _this[method] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var client = _this.lb.get();
                return client[method].apply(client, args);
            };
        });
    }
    GRPCHelper.prototype.waitForReady = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.lb.waitForReady()];
            });
        });
    };
    GRPCHelper.prototype.parseSDUri = function (sdUri) {
        var idx = sdUri.indexOf('://');
        var type = sdUri.slice(0, idx);
        var addr = sdUri.slice(idx + 3);
        return { type: type, addr: addr };
    };
    return GRPCHelper;
}());
exports.GRPCHelper = GRPCHelper;
//# sourceMappingURL=helper.js.map